xref: /openbmc/linux/scripts/link-vmlinux.sh (revision dfeab63a)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37is_enabled() {
38	grep -q "^$1=y" include/config/auto.conf
39}
40
41# Nice output in kbuild format
42# Will be supressed by "make -s"
43info()
44{
45	printf "  %-7s %s\n" "${1}" "${2}"
46}
47
48# Generate a linker script to ensure correct ordering of initcalls.
49gen_initcalls()
50{
51	info GEN .tmp_initcalls.lds
52
53	${PYTHON3} ${srctree}/scripts/jobserver-exec		\
54	${PERL} ${srctree}/scripts/generate_initcall_order.pl	\
55		${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}	\
56		> .tmp_initcalls.lds
57}
58
59# Link of vmlinux.o used for section mismatch analysis
60# ${1} output file
61modpost_link()
62{
63	local objects
64	local lds=""
65
66	objects="--whole-archive				\
67		${KBUILD_VMLINUX_OBJS}				\
68		--no-whole-archive				\
69		--start-group					\
70		${KBUILD_VMLINUX_LIBS}				\
71		--end-group"
72
73	if is_enabled CONFIG_LTO_CLANG; then
74		gen_initcalls
75		lds="-T .tmp_initcalls.lds"
76
77		# This might take a while, so indicate that we're doing
78		# an LTO link
79		info LTO ${1}
80	else
81		info LD ${1}
82	fi
83
84	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
85}
86
87objtool_link()
88{
89	local objtoolcmd;
90	local objtoolopt;
91
92	if ! is_enabled CONFIG_OBJTOOL; then
93		return;
94	fi
95
96	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
97
98		# For LTO and IBT, objtool doesn't run on individual
99		# translation units.  Run everything on vmlinux instead.
100
101		if is_enabled CONFIG_HAVE_JUMP_LABEL_HACK; then
102			objtoolopt="${objtoolopt} --hacks=jump_label"
103		fi
104
105		if is_enabled CONFIG_HAVE_NOINSTR_HACK; then
106			objtoolopt="${objtoolopt} --hacks=noinstr"
107		fi
108
109		if is_enabled CONFIG_X86_KERNEL_IBT; then
110			objtoolopt="${objtoolopt} --ibt"
111		fi
112
113		if is_enabled CONFIG_FTRACE_MCOUNT_USE_OBJTOOL; then
114			objtoolopt="${objtoolopt} --mcount"
115		fi
116
117		if is_enabled CONFIG_UNWINDER_ORC; then
118			objtoolopt="${objtoolopt} --orc"
119		fi
120
121		if is_enabled CONFIG_RETPOLINE; then
122			objtoolopt="${objtoolopt} --retpoline"
123		fi
124
125		if is_enabled CONFIG_SLS; then
126			objtoolopt="${objtoolopt} --sls"
127		fi
128
129		if is_enabled CONFIG_STACK_VALIDATION; then
130			objtoolopt="${objtoolopt} --stackval"
131		fi
132
133		if is_enabled CONFIG_HAVE_STATIC_CALL_INLINE; then
134			objtoolopt="${objtoolopt} --static-call"
135		fi
136
137		objtoolopt="${objtoolopt} --uaccess"
138	fi
139
140	if is_enabled CONFIG_NOINSTR_VALIDATION; then
141		objtoolopt="${objtoolopt} --noinstr"
142	fi
143
144	if [ -n "${objtoolopt}" ]; then
145
146		if is_enabled CONFIG_GCOV_KERNEL; then
147			objtoolopt="${objtoolopt} --no-unreachable"
148		fi
149
150		objtoolopt="${objtoolopt} --link"
151
152		info OBJTOOL ${1}
153		tools/objtool/objtool ${objtoolopt} ${1}
154	fi
155}
156
157# Link of vmlinux
158# ${1} - output file
159# ${2}, ${3}, ... - optional extra .o files
160vmlinux_link()
161{
162	local output=${1}
163	local objs
164	local libs
165	local ld
166	local ldflags
167	local ldlibs
168
169	info LD ${output}
170
171	# skip output file argument
172	shift
173
174	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
175		# Use vmlinux.o instead of performing the slow LTO link again.
176		objs=vmlinux.o
177		libs=
178	else
179		objs="${KBUILD_VMLINUX_OBJS}"
180		libs="${KBUILD_VMLINUX_LIBS}"
181	fi
182
183	if is_enabled CONFIG_MODULES; then
184		objs="${objs} .vmlinux.export.o"
185	fi
186
187	if [ "${SRCARCH}" = "um" ]; then
188		wl=-Wl,
189		ld="${CC}"
190		ldflags="${CFLAGS_vmlinux}"
191		ldlibs="-lutil -lrt -lpthread"
192	else
193		wl=
194		ld="${LD}"
195		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
196		ldlibs=
197	fi
198
199	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
200
201	# The kallsyms linking does not need debug symbols included.
202	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
203		ldflags="${ldflags} ${wl}--strip-debug"
204	fi
205
206	if is_enabled CONFIG_VMLINUX_MAP; then
207		ldflags="${ldflags} ${wl}-Map=${output}.map"
208	fi
209
210	${ld} ${ldflags} -o ${output}					\
211		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
212		${wl}--start-group ${libs} ${wl}--end-group		\
213		$@ ${ldlibs}
214}
215
216# generate .BTF typeinfo from DWARF debuginfo
217# ${1} - vmlinux image
218# ${2} - file to dump raw BTF data into
219gen_btf()
220{
221	local pahole_ver
222
223	if ! [ -x "$(command -v ${PAHOLE})" ]; then
224		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
225		return 1
226	fi
227
228	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
229	if [ "${pahole_ver}" -lt "116" ]; then
230		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
231		return 1
232	fi
233
234	vmlinux_link ${1}
235
236	info "BTF" ${2}
237	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
238
239	# Create ${2} which contains just .BTF section but no symbols. Add
240	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
241	# deletes all symbols including __start_BTF and __stop_BTF, which will
242	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
243	# objcopy warnings: "empty loadable segment detected at ..."
244	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
245		--strip-all ${1} ${2} 2>/dev/null
246	# Change e_type to ET_REL so that it can be used to link final vmlinux.
247	# Unlike GNU ld, lld does not allow an ET_EXEC input.
248	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
249}
250
251# Create ${2} .S file with all symbols from the ${1} object file
252kallsyms()
253{
254	local kallsymopt;
255
256	if is_enabled CONFIG_KALLSYMS_ALL; then
257		kallsymopt="${kallsymopt} --all-symbols"
258	fi
259
260	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
261		kallsymopt="${kallsymopt} --absolute-percpu"
262	fi
263
264	if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
265		kallsymopt="${kallsymopt} --base-relative"
266	fi
267
268	info KSYMS ${2}
269	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
270}
271
272# Perform one step in kallsyms generation, including temporary linking of
273# vmlinux.
274kallsyms_step()
275{
276	kallsymso_prev=${kallsymso}
277	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
278	kallsymso=${kallsyms_vmlinux}.o
279	kallsyms_S=${kallsyms_vmlinux}.S
280
281	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
282	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
283
284	info AS ${kallsyms_S}
285	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
286	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
287	      -c -o ${kallsymso} ${kallsyms_S}
288}
289
290# Create map file with all symbols from ${1}
291# See mksymap for additional details
292mksysmap()
293{
294	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
295}
296
297sorttable()
298{
299	${objtree}/scripts/sorttable ${1}
300}
301
302# Delete output files in case of error
303cleanup()
304{
305	rm -f .btf.*
306	rm -f .tmp_System.map
307	rm -f .tmp_initcalls.lds
308	rm -f .tmp_vmlinux*
309	rm -f System.map
310	rm -f vmlinux
311	rm -f vmlinux.map
312	rm -f vmlinux.o
313	rm -f .vmlinux.d
314	rm -f .vmlinux.objs
315	rm -f .vmlinux.export.c
316}
317
318# Use "make V=1" to debug this script
319case "${KBUILD_VERBOSE}" in
320*1*)
321	set -x
322	;;
323esac
324
325if [ "$1" = "clean" ]; then
326	cleanup
327	exit 0
328fi
329
330# Update version
331info GEN .version
332if [ -r .version ]; then
333	VERSION=$(expr 0$(cat .version) + 1)
334	echo $VERSION > .version
335else
336	rm -f .version
337	echo 1 > .version
338fi;
339
340# final build of init/
341${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
342
343#link vmlinux.o
344modpost_link vmlinux.o
345objtool_link vmlinux.o
346
347# Generate the list of objects in vmlinux
348for f in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
349	case ${f} in
350	*.a)
351		${AR} t ${f} ;;
352	*)
353		echo ${f} ;;
354	esac
355done > .vmlinux.objs
356
357# modpost vmlinux.o to check for section mismatches
358${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
359
360info MODINFO modules.builtin.modinfo
361${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
362info GEN modules.builtin
363# The second line aids cases where multiple modules share the same object.
364tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
365	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
366
367if is_enabled CONFIG_MODULES; then
368	${MAKE} -f "${srctree}/scripts/Makefile.vmlinux" .vmlinux.export.o
369fi
370
371btf_vmlinux_bin_o=""
372if is_enabled CONFIG_DEBUG_INFO_BTF; then
373	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
374	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
375		echo >&2 "Failed to generate BTF for vmlinux"
376		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
377		exit 1
378	fi
379fi
380
381kallsymso=""
382kallsymso_prev=""
383kallsyms_vmlinux=""
384if is_enabled CONFIG_KALLSYMS; then
385
386	# kallsyms support
387	# Generate section listing all symbols and add it into vmlinux
388	# It's a three step process:
389	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
390	#     but __kallsyms is empty.
391	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
392	#     the right size
393	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
394	#     the right size, but due to the added section, some
395	#     addresses have shifted.
396	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
397	# 3)  That link may have expanded the kernel image enough that
398	#     more linker branch stubs / trampolines had to be added, which
399	#     introduces new names, which further expands kallsyms. Do another
400	#     pass if that is the case. In theory it's possible this results
401	#     in even more stubs, but unlikely.
402	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
403	#     other bugs.
404	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
405	#
406	# a)  Verify that the System.map from vmlinux matches the map from
407	#     ${kallsymso}.
408
409	kallsyms_step 1
410	kallsyms_step 2
411
412	# step 3
413	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
414	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
415
416	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
417		kallsyms_step 3
418	fi
419fi
420
421vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
422
423# fill in BTF IDs
424if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
425	info BTFIDS vmlinux
426	${RESOLVE_BTFIDS} vmlinux
427fi
428
429info SYSMAP System.map
430mksysmap vmlinux System.map
431
432if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
433	info SORTTAB vmlinux
434	if ! sorttable vmlinux; then
435		echo >&2 Failed to sort kernel tables
436		exit 1
437	fi
438fi
439
440# step a (see comment above)
441if is_enabled CONFIG_KALLSYMS; then
442	mksysmap ${kallsyms_vmlinux} .tmp_System.map
443
444	if ! cmp -s System.map .tmp_System.map; then
445		echo >&2 Inconsistent kallsyms data
446		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
447		exit 1
448	fi
449fi
450
451# For fixdep
452echo "vmlinux: $0" > .vmlinux.d
453